package OSexamples;

public class our_monitor { //this is a monitor for thread syncronization
	private int buffer[] = new int[OSexamples.ProducerConsumer.N];
	private int count=0, lo=0, hi=0; //counter and indices
	
	public synchronized void insert(int val){
		if (count==OSexamples.ProducerConsumer.N) go_to_sleep(); //if the buffer is full, go to sleep
		buffer[hi]=val; //insert an item into the buffer
		System.out.println("This is the synchronized process. Inserting produced item at buffer[" + hi +"] item is = "+ buffer[hi]);
		hi = (hi+1)% OSexamples.ProducerConsumer.N; //slot to place next item in
		count =count+1; //one more item in the buffer now
		if (count==1) notify();  //if consumer was sleeping, wake it up
	}
	
	public synchronized int remove(){
		int val;
		if(count==0) go_to_sleep();  //if the buffer is empty, go to sleep
		val=buffer[lo]; //fetch an item from the buffer
		System.out.println("This is the other synchronized process. Removing item from buffer[" + lo +"] = "+ buffer[lo]);
		lo=(lo+1)% OSexamples.ProducerConsumer.N; //slot to fetch next item from
		count = count-1; //one less item in the buffer
		if (count == OSexamples.ProducerConsumer.N - 1) notify(); //if producer was sleeping, wake it up
		return val;
	}
	
	
	private void go_to_sleep(){
		try{
			wait();
		}
		catch(InterruptedException ex){}
	}

}
